libstdc++: __gnu_cxx::enc_filebuf< _CharT > Class Template Reference

libstdc++

__gnu_cxx::enc_filebuf< _CharT > Class Template Reference

`#include <enc_filebuf.h>`

Inheritance diagram for __gnu_cxx::enc_filebuf< _CharT >:
[legend]

## Public Types
typedef codecvt< char_type, char, __state_type > | __codecvt_type
typedef __basic_file< char > | __file_type
typedef basic_filebuf< char_type, traits_type > | __filebuf_type
typedef traits_type::state_type | __state_type
typedef basic_streambuf< char_type, traits_type > | __streambuf_type
typedef _CharT | char_type
typedef traits_type::int_type | int_type
typedef traits_type::off_type | off_type
typedef traits_type::pos_type | pos_type
typedef traits_type::state_type | state_type
typedef encoding_char_traits< _CharT > | traits_type

## Public Member Functions
| enc_filebuf (state_type &__state)
__filebuf_type * | close ()
locale | getloc () const
streamsize | in_avail ()
bool | is_open () const throw ()
__filebuf_type * | open (const char *__s, ios_base::openmode __mode)
locale | pubimbue (const locale &__loc)
int_type | sbumpc ()
int_type | sgetc ()
streamsize | sgetn (char_type *__s, streamsize __n)
int_type | snextc ()
int_type | sputbackc (char_type __c)
int_type | sputc (char_type __c)
streamsize | sputn (const char_type *__s, streamsize __n)
int_type | sungetc ()
void | swap (basic_filebuf &)
basic_streambuf * | pubsetbuf (char_type *__s, streamsize __n)
pos_type | pubseekoff (off_type __off, ios_base::seekdir __way, ios_base::openmode __mode=ios_base::in|ios_base::out)
pos_type | pubseekpos (pos_type __sp, ios_base::openmode __mode=ios_base::in|ios_base::out)
int | pubsync ()

## Protected Member Functions
void | __safe_gbump (streamsize __n)
void | __safe_pbump (streamsize __n)
void | _M_allocate_internal_buffer ()
bool | _M_convert_to_external (char_type *, streamsize)
void | _M_create_pback ()
void | _M_destroy_internal_buffer () throw ()
void | _M_destroy_pback () throw ()
int | _M_get_ext_pos (__state_type &__state)
pos_type | _M_seek (off_type __off, ios_base::seekdir __way, __state_type __state)
void | _M_set_buffer (streamsize __off)
bool | _M_terminate_output ()
void | gbump (int __n)
virtual void | imbue (const locale &__loc)
virtual int_type | overflow (int_type __c=encoding_char_traits< _CharT >::eof())
virtual int_type | pbackfail (int_type __c=encoding_char_traits< _CharT >::eof())
void | pbump (int __n)
virtual pos_type | seekoff (off_type __off, ios_base::seekdir __way, ios_base::openmode __mode=ios_base::in|ios_base::out)
virtual pos_type | seekpos (pos_type __pos, ios_base::openmode __mode=ios_base::in|ios_base::out)
virtual __streambuf_type * | setbuf (char_type *__s, streamsize __n)
void | setg (char_type *__gbeg, char_type *__gnext, char_type *__gend)
void | setp (char_type *__pbeg, char_type *__pend)
virtual streamsize | showmanyc ()
void | swap (basic_streambuf &__sb)
virtual int | sync ()
virtual int_type | uflow ()
virtual int_type | underflow ()
virtual streamsize | xsgetn (char_type *__s, streamsize __n)
virtual streamsize | xsputn (const char_type *__s, streamsize __n)
char_type * | eback () const
char_type * | gptr () const
char_type * | egptr () const
char_type * | pbase () const
char_type * | pptr () const
char_type * | epptr () const

## Protected Attributes
char_type * | _M_buf
bool | _M_buf_allocated
locale | _M_buf_locale
size_t | _M_buf_size
const __codecvt_type * | _M_codecvt
char * | _M_ext_buf
streamsize | _M_ext_buf_size
char * | _M_ext_end
const char * | _M_ext_next
__file_type | _M_file
char_type * | _M_in_beg
char_type * | _M_in_cur
char_type * | _M_in_end
__c_lock | _M_lock
ios_base::openmode | _M_mode
char_type * | _M_out_beg
char_type * | _M_out_cur
char_type * | _M_out_end
bool | _M_reading
__state_type | _M_state_beg
__state_type | _M_state_cur
__state_type | _M_state_last
bool | _M_writing
char_type | _M_pback
char_type * | _M_pback_cur_save
char_type * | _M_pback_end_save
bool | _M_pback_init

## Detailed Description

template<typename _CharT>
class __gnu_cxx::enc_filebuf< _CharT >

class enc_filebuf.

Definition at line 44 of file enc_filebuf.h.

## Member Typedef Documentation

## ◆ __codecvt_type

typedef codecvt<char_type, char, __state_type> std::basic_filebuf< _CharT, encoding_char_traits< _CharT > >::__codecvt_type
| inherited

Definition at line 120 of file fstream.

## ◆ __file_type

typedef __basic_file<char> std::basic_filebuf< _CharT, encoding_char_traits< _CharT > >::__file_type
| inherited

Definition at line 118 of file fstream.

## ◆ __filebuf_type

typedef basic_filebuf<char_type, traits_type> std::basic_filebuf< _CharT, encoding_char_traits< _CharT > >::__filebuf_type
| inherited

Definition at line 117 of file fstream.

## ◆ __state_type

typedef traits_type::state_type std::basic_filebuf< _CharT, encoding_char_traits< _CharT > >::__state_type
| inherited

Definition at line 119 of file fstream.

## ◆ __streambuf_type

typedef basic_streambuf<char_type, traits_type> std::basic_filebuf< _CharT, encoding_char_traits< _CharT > >::__streambuf_type
| inherited

Definition at line 116 of file fstream.

## ◆ char_type

typedef _CharT std::basic_filebuf< _CharT, encoding_char_traits< _CharT > >::char_type
| inherited

Definition at line 110 of file fstream.

## ◆ int_type

typedef traits_type::int_type std::basic_filebuf< _CharT, encoding_char_traits< _CharT > >::int_type
| inherited

Definition at line 112 of file fstream.

## ◆ off_type

typedef traits_type::off_type std::basic_filebuf< _CharT, encoding_char_traits< _CharT > >::off_type
| inherited

Definition at line 114 of file fstream.

## ◆ pos_type

template<typename _CharT>

typedef traits_type::pos_type __gnu_cxx::enc_filebuf< _CharT >::pos_type

Definition at line 50 of file enc_filebuf.h.

## ◆ state_type

template<typename _CharT>

typedef traits_type::state_type __gnu_cxx::enc_filebuf< _CharT >::state_type

Definition at line 49 of file enc_filebuf.h.

## ◆ traits_type

template<typename _CharT>

typedef encoding_char_traits<_CharT> __gnu_cxx::enc_filebuf< _CharT >::traits_type

Definition at line 48 of file enc_filebuf.h.

## Constructor & Destructor Documentation

## ◆ enc_filebuf()

template<typename _CharT>

__gnu_cxx::enc_filebuf< _CharT >::enc_filebuf | ( | state_type & | __state | ) |
| inline

Definition at line 52 of file enc_filebuf.h.

## Member Function Documentation

## ◆ __safe_gbump()

void std::basic_streambuf< _CharT, encoding_char_traits< _CharT > >::__safe_gbump | ( | streamsize | __n | ) |
| inlineprotectedinherited

Definition at line 804 of file streambuf.

## ◆ __safe_pbump()

void std::basic_streambuf< _CharT, encoding_char_traits< _CharT > >::__safe_pbump | ( | streamsize | __n | ) |
| inlineprotectedinherited

Definition at line 807 of file streambuf.

## ◆ _M_allocate_internal_buffer()

void std::basic_filebuf< _CharT, encoding_char_traits< _CharT > >::_M_allocate_internal_buffer | ( |  | ) |
| protectedinherited

Definition at line 408 of file fstream.tcc.

## ◆ _M_convert_to_external()

bool std::basic_filebuf< _CharT, encoding_char_traits< _CharT > >::_M_convert_to_external | ( | char_type * | __ibuf,
|  | streamsize | __ilen )
| protectedinherited

Definition at line 441 of file fstream.tcc.

## ◆ _M_create_pback()

void std::basic_filebuf< _CharT, encoding_char_traits< _CharT > >::_M_create_pback | ( |  | ) |
| inlineprotectedinherited

Initializes pback buffers, and moves normal buffers to safety. Assumptions: _M_in_cur has already been moved back

Definition at line 211 of file fstream.

## ◆ _M_destroy_internal_buffer()

void std::basic_filebuf< _CharT, encoding_char_traits< _CharT > >::_M_destroy_internal_buffer | ( |  | ) |
throw | ( | ) |  |  |
| protectedinherited

Definition at line 411 of file fstream.tcc.

## ◆ _M_destroy_pback()

void std::basic_filebuf< _CharT, encoding_char_traits< _CharT > >::_M_destroy_pback | ( |  | ) |
throw | ( | ) |  |  |
| inlineprotectedinherited

Deactivates pback buffer contents, and restores normal buffer. Assumptions: The pback buffer has only moved forward.

Definition at line 228 of file fstream.

## ◆ _M_get_ext_pos()

int std::basic_filebuf< _CharT, encoding_char_traits< _CharT > >::_M_get_ext_pos | ( | __state_type & | __state | ) |
| protectedinherited

Definition at line 471 of file fstream.tcc.

## ◆ _M_seek()

basic_filebuf< _CharT, encoding_char_traits< _CharT > >::pos_type std::basic_filebuf< _CharT, encoding_char_traits< _CharT > >::_M_seek | ( | off_type | __off,
|  | ios_base::seekdir | __way,
|  | __state_type | __state )
| protectedinherited

Definition at line 468 of file fstream.tcc.

## ◆ _M_set_buffer()

void std::basic_filebuf< _CharT, encoding_char_traits< _CharT > >::_M_set_buffer | ( | streamsize | __off | ) |
| inlineprotectedinherited

This function sets the pointers of the internal buffer, both get and put areas. Typically:

__off == egptr() - eback() upon underflow/uflow (read mode); __off == 0 upon overflow (write mode); __off == -1 upon open, setbuf, seekoff/pos (uncommitted mode).

NB: epptr() - pbase() == _M_buf_size - 1, since _M_buf_size reflects the actual allocated memory and the last cell is reserved for the overflow char of a full put area.

Definition at line 502 of file fstream.

Referenced by seekpos(), and setbuf().

## ◆ _M_terminate_output()

bool std::basic_filebuf< _CharT, encoding_char_traits< _CharT > >::_M_terminate_output | ( |  | ) |
| protectedinherited

Definition at line 487 of file fstream.tcc.

## ◆ close()

basic_filebuf< _CharT, encoding_char_traits< _CharT > >::__filebuf_type * std::basic_filebuf< _CharT, encoding_char_traits< _CharT > >::close | ( |  | ) |
| inherited

Closes the currently associated file.

Returns
  `this` on success, NULL on failure

If no file is currently open, this function immediately fails.

If a put buffer area exists, `overflow(eof)` is called to flush all the characters. The file is then closed.

If any operations fail, this function also fails.

Definition at line 374 of file fstream.tcc.

## ◆ eback()

char_type * std::basic_streambuf< _CharT, encoding_char_traits< _CharT > >::eback | ( |  | ) | const
| inlineprotectedinherited

Access to the get area.

These functions are only available to other protected functions, including derived classes.

- eback() returns the beginning pointer for the input sequence
- gptr() returns the next pointer for the input sequence
- egptr() returns the end pointer for the input sequence

Definition at line 491 of file streambuf.

## ◆ egptr()

char_type * std::basic_streambuf< _CharT, encoding_char_traits< _CharT > >::egptr | ( |  | ) | const
| inlineprotectedinherited

Access to the get area.

These functions are only available to other protected functions, including derived classes.

- eback() returns the beginning pointer for the input sequence
- gptr() returns the next pointer for the input sequence
- egptr() returns the end pointer for the input sequence

Definition at line 497 of file streambuf.

## ◆ epptr()

char_type * std::basic_streambuf< _CharT, encoding_char_traits< _CharT > >::epptr | ( |  | ) | const
| inlineprotectedinherited

Access to the put area.

These functions are only available to other protected functions, including derived classes.

- pbase() returns the beginning pointer for the output sequence
- pptr() returns the next pointer for the output sequence
- epptr() returns the end pointer for the output sequence

Definition at line 544 of file streambuf.

## ◆ gbump()

void std::basic_streambuf< _CharT, encoding_char_traits< _CharT > >::gbump | ( | int | __n | ) |
| inlineprotectedinherited

Moving the read position.

Parameters

  __n | The delta by which to move.

This just advances the read position without returning any data.

Definition at line 507 of file streambuf.

## ◆ getloc()

locale std::basic_streambuf< _CharT, encoding_char_traits< _CharT > >::getloc | ( |  | ) | const
| inlineinherited

Locale access.

Returns
  The current locale in effect.

If pubimbue(loc) has been called, then the most recent `loc` is returned. Otherwise the global locale in effect at the time of construction is returned.

Definition at line 235 of file streambuf.

## ◆ gptr()

char_type * std::basic_streambuf< _CharT, encoding_char_traits< _CharT > >::gptr | ( |  | ) | const
| inlineprotectedinherited

Access to the get area.

These functions are only available to other protected functions, including derived classes.

- eback() returns the beginning pointer for the input sequence
- gptr() returns the next pointer for the input sequence
- egptr() returns the end pointer for the input sequence

Definition at line 494 of file streambuf.

## ◆ imbue()

void std::basic_filebuf< _CharT, encoding_char_traits< _CharT > >::imbue | ( | const locale & | __loc | ) |
| protectedvirtualinherited

Changes translations.

Parameters

  __loc | A new locale.

Translations done during I/O which depend on the current locale are changed by this call. The standard adds, Between invocations of this function a class derived from streambuf can safely cache results of calls to locale functions and to members of facets so obtained.

Note
  Base class version does nothing.

Reimplemented from std::basic_streambuf< _CharT, encoding_char_traits< _CharT > >.

Definition at line 477 of file fstream.tcc.

## ◆ in_avail()

streamsize std::basic_streambuf< _CharT, encoding_char_traits< _CharT > >::in_avail | ( |  | ) |
| inlineinherited

Looking ahead into the stream.

Returns
  The number of characters available.

If a read position is available, returns the number of characters available for reading before the buffer must be refilled. Otherwise returns the derived `showmanyc()`.

Definition at line 293 of file streambuf.

## ◆ is_open()

bool std::basic_filebuf< _CharT, encoding_char_traits< _CharT > >::is_open | ( |  | ) | const
throw | ( | ) |  |  |
| inlinenodiscardinherited

Returns true if the external file is open.

Definition at line 278 of file fstream.

## ◆ open()

basic_filebuf< _CharT, encoding_char_traits< _CharT > >::__filebuf_type * std::basic_filebuf< _CharT, encoding_char_traits< _CharT > >::open | ( | const char * | __s,
|  | ios_base::openmode | __mode )
| inherited

Opens an external file.

Parameters

  __s | The name of the file.
  __mode | The open mode flags.

Returns
  `this` on success, NULL on failure

If a file is already open, this function immediately fails. Otherwise it tries to open the file named __s using the flags given in __mode.

Table 92, adapted here, gives the relation between openmode combinations and the equivalent `fopen()` flags. (NB: lines app, in|out|app, in|app, binary|app, binary|in|out|app, and binary|in|app per DR 596)

    +---------------------------------------------------------+
    | ios_base Flag combination            stdio equivalent   |
    |binary  in  out  trunc  app                              |
    +---------------------------------------------------------+
    |             +                        w                  |
    |             +           +            a                  |
    |                         +            a                  |
    |             +     +                  w                  |
    |         +                            r                  |
    |         +   +                        r+                 |
    |         +   +     +                  w+                 |
    |         +   +           +            a+                 |
    |         +               +            a+                 |
    +---------------------------------------------------------+
    |   +         +                        wb                 |
    |   +         +           +            ab                 |
    |   +                     +            ab                 |
    |   +         +     +                  wb                 |
    |   +     +                            rb                 |
    |   +     +   +                        r+b                |
    |   +     +   +     +                  w+b                |
    |   +     +   +           +            a+b                |
    |   +     +               +            a+b                |
    +---------------------------------------------------------+

Definition at line 323 of file fstream.tcc.

## ◆ overflow()

basic_filebuf< _CharT, encoding_char_traits< _CharT > >::int_type std::basic_filebuf< _CharT, encoding_char_traits< _CharT > >::overflow | ( | int_type | __c = _Traits::eof() | ) |
| protectedvirtualinherited

Consumes data from the buffer; writes to the controlled sequence.

Parameters

  __c | An additional character to consume.

Returns
  eof() to indicate failure, something else (usually __c, or not_eof())

Informally, this function is called when the output buffer is full (or does not exist, as buffering need not actually be done). If a buffer exists, it is consumed, with some effect on the controlled sequence. (Typically, the buffer is written out to the sequence verbatim.) In either case, the character c is also written out, if __c is not `eof()`.

For a formal definition of this function, see a good text such as Langer & Kreft, or [27.5.2.4.5]/3-7.

A functioning output streambuf can be created by overriding only this function (no buffer area will be used).

Note
  Base class version does nothing, returns eof().

Reimplemented from std::basic_streambuf< _CharT, encoding_char_traits< _CharT > >.

Definition at line 436 of file fstream.tcc.

References _M_ext_buf, _M_ext_next, and eback().

## ◆ pbackfail()

basic_filebuf< _CharT, encoding_char_traits< _CharT > >::int_type std::basic_filebuf< _CharT, encoding_char_traits< _CharT > >::pbackfail | ( | int_type | __c = _Traits::eof() | ) |
| protectedvirtualinherited

Tries to back up the input sequence.

Parameters

  __c | The character to be inserted back into the sequence.

Returns
  eof() on failure, some other value on success

Postcondition
  The constraints of `gptr()`, `eback()`, and `pptr()` are the same as for `underflow()`.

Note
  Base class version does nothing, returns eof().

Reimplemented from std::basic_streambuf< _CharT, encoding_char_traits< _CharT > >.

Definition at line 426 of file fstream.tcc.

References _M_ext_buf, _M_ext_next, and eback().

## ◆ pbase()

char_type * std::basic_streambuf< _CharT, encoding_char_traits< _CharT > >::pbase | ( |  | ) | const
| inlineprotectedinherited

Access to the put area.

These functions are only available to other protected functions, including derived classes.

- pbase() returns the beginning pointer for the output sequence
- pptr() returns the next pointer for the output sequence
- epptr() returns the end pointer for the output sequence

Definition at line 538 of file streambuf.

## ◆ pbump()

void std::basic_streambuf< _CharT, encoding_char_traits< _CharT > >::pbump | ( | int | __n | ) |
| inlineprotectedinherited

Moving the write position.

Parameters

  __n | The delta by which to move.

This just advances the write position without returning any data.

Definition at line 554 of file streambuf.

## ◆ pptr()

char_type * std::basic_streambuf< _CharT, encoding_char_traits< _CharT > >::pptr | ( |  | ) | const
| inlineprotectedinherited

Access to the put area.

These functions are only available to other protected functions, including derived classes.

- pbase() returns the beginning pointer for the output sequence
- pptr() returns the next pointer for the output sequence
- epptr() returns the end pointer for the output sequence

Definition at line 541 of file streambuf.

## ◆ pubimbue()

locale std::basic_streambuf< _CharT, encoding_char_traits< _CharT > >::pubimbue | ( | const locale & | __loc | ) |
| inlineinherited

Entry point for imbue().

Parameters

  __loc | The new locale.

Returns
  The previous locale.

Calls the derived imbue(__loc).

Definition at line 218 of file streambuf.

## ◆ pubseekoff()

pos_type std::basic_streambuf< _CharT, encoding_char_traits< _CharT > >::pubseekoff | ( | off_type | __off,
|  | ios_base::seekdir | __way,
|  | ios_base::openmode | __mode = ios_base::in | ios_base::out )
| inlineinherited

Alters the stream position.

Parameters

  __off | Offset.
  __way | Value for ios_base::seekdir.
  __mode | Value for ios_base::openmode.

Calls virtual seekoff function.

Definition at line 260 of file streambuf.

## ◆ pubseekpos()

pos_type std::basic_streambuf< _CharT, encoding_char_traits< _CharT > >::pubseekpos | ( | pos_type | __sp,
|  | ios_base::openmode | __mode = ios_base::in | ios_base::out )
| inlineinherited

Alters the stream position.

Parameters

  __sp | Position
  __mode | Value for ios_base::openmode.

Calls virtual seekpos function.

Definition at line 272 of file streambuf.

## ◆ pubsetbuf()

basic_streambuf * std::basic_streambuf< _CharT, encoding_char_traits< _CharT > >::pubsetbuf | ( | char_type * | __s,
|  | streamsize | __n )
| inlineinherited

Entry points for derived buffer functions.

The public versions of `pubfoo` dispatch to the protected derived `foo` member functions, passing the arguments (if any) and returning the result unchanged.

Definition at line 248 of file streambuf.

## ◆ pubsync()

int std::basic_streambuf< _CharT, encoding_char_traits< _CharT > >::pubsync | ( |  | ) |
| inlineinherited

Calls virtual sync function.

Definition at line 280 of file streambuf.

## ◆ sbumpc()

int_type std::basic_streambuf< _CharT, encoding_char_traits< _CharT > >::sbumpc | ( |  | ) |
| inlineinherited

Getting the next character.

Returns
  The next character, or eof.

If the input read position is available, returns that character and increments the read pointer, otherwise calls and returns `uflow()`.

Definition at line 325 of file streambuf.

## ◆ seekoff()

basic_filebuf< _CharT, encoding_char_traits< _CharT > >::pos_type std::basic_filebuf< _CharT, encoding_char_traits< _CharT > >::seekoff | ( | off_type | __off,
|  | ios_base::seekdir | __way,
|  | ios_base::openmode | __mode = ios_base::in | ios_base::out )
| protectedvirtualinherited

Alters the stream positions.

Each derived class provides its own appropriate behavior.

Note
  Base class version does nothing, returns a `pos_type` that represents an invalid stream position.

Reimplemented from std::basic_streambuf< _CharT, encoding_char_traits< _CharT > >.

Definition at line 459 of file fstream.tcc.

References gptr().

## ◆ seekpos()

basic_filebuf< _CharT, encoding_char_traits< _CharT > >::pos_type std::basic_filebuf< _CharT, encoding_char_traits< _CharT > >::seekpos | ( | pos_type | __pos,
|  | ios_base::openmode | __mode = ios_base::in | ios_base::out )
| protectedvirtualinherited

Alters the stream positions.

Each derived class provides its own appropriate behavior.

Note
  Base class version does nothing, returns a `pos_type` that represents an invalid stream position.

Reimplemented from std::basic_streambuf< _CharT, encoding_char_traits< _CharT > >.

Definition at line 463 of file fstream.tcc.

References _M_reading, and _M_set_buffer().

## ◆ setbuf()

basic_filebuf< _CharT, encoding_char_traits< _CharT > >::__streambuf_type * std::basic_filebuf< _CharT, encoding_char_traits< _CharT > >::setbuf | ( | char_type * | __s,
|  | streamsize | __n )
| protectedvirtualinherited

Manipulates the buffer.

Parameters

  __s | Pointer to a buffer area.
  __n | Size of __s.

Returns
  `this`

If no file has been opened, and both __s and __n are zero, then the stream becomes unbuffered. Otherwise, `__s` is used as a buffer; see https://gcc.gnu.org/onlinedocs/libstdc++/manual/streambufs.html#io.streambuf.buffering for more.

Reimplemented from std::basic_streambuf< _CharT, encoding_char_traits< _CharT > >.

Definition at line 456 of file fstream.tcc.

References _M_reading, and _M_set_buffer().

## ◆ setg()

void std::basic_streambuf< _CharT, encoding_char_traits< _CharT > >::setg | ( | char_type * | __gbeg,
|  | char_type * | __gnext,
|  | char_type * | __gend )
| inlineprotectedinherited

Setting the three read area pointers.

Parameters

  __gbeg | A pointer.
  __gnext | A pointer.
  __gend | A pointer.

Postcondition
  __gbeg == `eback()`, __gnext == `gptr()`, and __gend == `egptr()`

Definition at line 518 of file streambuf.

## ◆ setp()

void std::basic_streambuf< _CharT, encoding_char_traits< _CharT > >::setp | ( | char_type * | __pbeg,
|  | char_type * | __pend )
| inlineprotectedinherited

Setting the three write area pointers.

Parameters

  __pbeg | A pointer.
  __pend | A pointer.

Postcondition
  __pbeg == `pbase()`, __pbeg == `pptr()`, and __pend == `epptr()`

Definition at line 564 of file streambuf.

## ◆ sgetc()

int_type std::basic_streambuf< _CharT, encoding_char_traits< _CharT > >::sgetc | ( |  | ) |
| inlineinherited

Getting the next character.

Returns
  The next character, or eof.

If the input read position is available, returns that character, otherwise calls and returns `underflow()`. Does not move the read position after fetching the character.

Definition at line 347 of file streambuf.

## ◆ sgetn()

streamsize std::basic_streambuf< _CharT, encoding_char_traits< _CharT > >::sgetn | ( | char_type * | __s,
|  | streamsize | __n )
| inlineinherited

Entry point for xsgetn.

Parameters

  __s | A buffer area.
  __n | A count.

Returns xsgetn(__s,__n). The effect is to fill __s[0] through __s[__n-1] with characters from the input sequence, if possible.

Definition at line 366 of file streambuf.

## ◆ showmanyc()

streamsize std::basic_filebuf< _CharT, encoding_char_traits< _CharT > >::showmanyc | ( |  | ) |
| protectedvirtualinherited

Investigating the data available.

Returns
  An estimate of the number of characters available in the input sequence, or -1.

If it returns a positive value, then successive calls to `underflow()` will not return `traits::eof()` until at least that number of characters have been supplied. If `showmanyc()` returns -1, then calls to `underflow()` or `uflow()` will fail. [27.5.2.4.3]/1

Note
  Base class version does nothing, returns zero.
  The standard adds that the intention is not only that the calls [to underflow or uflow] will not return `eof()` but that they will return immediately.
  The standard adds that the morphemes of `showmanyc` are es-how-many-see, not show-manic.

Reimplemented from std::basic_streambuf< _CharT, encoding_char_traits< _CharT > >.

Definition at line 415 of file fstream.tcc.

## ◆ snextc()

int_type std::basic_streambuf< _CharT, encoding_char_traits< _CharT > >::snextc | ( |  | ) |
| inlineinherited

Getting the next character.

Returns
  The next character, or eof.

Calls `sbumpc()`, and if that function returns `traits::eof()`, so does this function. Otherwise, `sgetc()`.

Definition at line 307 of file streambuf.

## ◆ sputbackc()

int_type std::basic_streambuf< _CharT, encoding_char_traits< _CharT > >::sputbackc | ( | char_type | __c | ) |
| inlineinherited

Pushing characters back into the input stream.

Parameters

  __c | The character to push back.

Returns
  The previous character, if possible.

Similar to sungetc(), but __c is pushed onto the stream instead of the previous character. If successful, the next character fetched from the input stream will be __c.

Definition at line 381 of file streambuf.

## ◆ sputc()

int_type std::basic_streambuf< _CharT, encoding_char_traits< _CharT > >::sputc | ( | char_type | __c | ) |
| inlineinherited

Entry point for all single-character output functions.

Parameters

  __c | A character to output.

Returns
  __c, if possible.

One of two public output functions.

If a write position is available for the output sequence (i.e., the buffer is not full), stores __c in that position, increments the position, and returns `traits::to_int_type(__c)`. If a write position is not available, returns `overflow(__c)`.

Definition at line 433 of file streambuf.

## ◆ sputn()

streamsize std::basic_streambuf< _CharT, encoding_char_traits< _CharT > >::sputn | ( | const char_type * | __s,
|  | streamsize | __n )
| inlineinherited

Entry point for all single-character output functions.

Parameters

  __s | A buffer read area.
  __n | A count.

One of two public output functions.

Returns xsputn(__s,__n). The effect is to write __s[0] through __s[__n-1] to the output sequence, if possible.

Definition at line 459 of file streambuf.

## ◆ sungetc()

int_type std::basic_streambuf< _CharT, encoding_char_traits< _CharT > >::sungetc | ( |  | ) |
| inlineinherited

Moving backwards in the input stream.

Returns
  The previous character, if possible.

If a putback position is available, this function decrements the input pointer and returns that character. Otherwise, calls and returns pbackfail(). The effect is to unget the last character gotten.

Definition at line 406 of file streambuf.

## ◆ swap() [1/2]

void std::basic_filebuf< _CharT, encoding_char_traits< _CharT > >::swap | ( | basic_filebuf< _CharT, encoding_char_traits< _CharT > > & | __rhs | ) |
| inherited

Definition at line 269 of file fstream.tcc.

## ◆ swap() [2/2]

void std::basic_streambuf< _CharT, encoding_char_traits< _CharT > >::swap | ( | basic_streambuf< _CharT, encoding_char_traits< _CharT > > & | __sb | ) |
| inlineprotectedinherited

Definition at line 821 of file streambuf.

## ◆ sync()

int std::basic_filebuf< _CharT, encoding_char_traits< _CharT > >::sync | ( |  | ) |
| protectedvirtualinherited

Synchronizes the buffer arrays with the controlled sequences.

Returns
  -1 on failure.

Each derived class provides its own appropriate behavior, including the definition of failure.

Note
  Base class version does nothing, returns zero.

Reimplemented from std::basic_streambuf< _CharT, encoding_char_traits< _CharT > >.

Definition at line 474 of file fstream.tcc.

## ◆ uflow()

virtual int_type std::basic_streambuf< _CharT, encoding_char_traits< _CharT > >::uflow | ( |  | ) |
| inlineprotectedvirtualinherited

Fetches more data from the controlled sequence.

Returns
  The first character from the pending sequence.

Informally, this function does the same thing as `underflow()`, and in fact is required to call that function. It also returns the new character, like `underflow()` does. However, this function also moves the read position forward by one.

Definition at line 709 of file streambuf.

## ◆ underflow()

basic_filebuf< _CharT, encoding_char_traits< _CharT > >::int_type std::basic_filebuf< _CharT, encoding_char_traits< _CharT > >::underflow | ( |  | ) |
| protectedvirtualinherited

Fetches more data from the controlled sequence.

Returns
  The first character from the pending sequence.

Informally, this function is called when the input buffer is exhausted (or does not exist, as buffering need not actually be done). If a buffer exists, it is refilled. In either case, the next available character is returned, or `traits::eof()` to indicate a null pending sequence.

For a formal definition of the pending sequence, see a good text such as Langer & Kreft, or [27.5.2.4.3]/7-14.

A functioning input streambuf can be created by overriding only this function (no buffer area will be used). For an example, see https://gcc.gnu.org/onlinedocs/libstdc++/manual/streambufs.html

Note
  Base class version does nothing, returns eof().

Reimplemented from std::basic_streambuf< _CharT, encoding_char_traits< _CharT > >.

Definition at line 423 of file fstream.tcc.

## ◆ xsgetn()

streamsize std::basic_filebuf< _CharT, encoding_char_traits< _CharT > >::xsgetn | ( | char_type * | __s,
|  | streamsize | __n )
| protectedvirtualinherited

Multiple character extraction.

Parameters

  __s | A buffer area.
  __n | Maximum number of characters to assign.

Returns
  The number of characters assigned.

Fills __s[0] through __s[__n-1] with characters from the input sequence, as if by `sbumpc()`. Stops when either __n characters have been copied, or when `traits::eof()` would be copied.

It is expected that derived classes provide a more efficient implementation by overriding this definition.

Reimplemented from std::basic_streambuf< _CharT, encoding_char_traits< _CharT > >.

Definition at line 480 of file fstream.tcc.

## ◆ xsputn()

streamsize std::basic_filebuf< _CharT, encoding_char_traits< _CharT > >::xsputn | ( | const char_type * | __s,
|  | streamsize | __n )
| protectedvirtualinherited

Multiple character insertion.

Parameters

  __s | A buffer area.
  __n | Maximum number of characters to write.

Returns
  The number of characters written.

Writes __s[0] through __s[__n-1] to the output sequence, as if by `sputc()`. Stops when either n characters have been copied, or when `sputc()` would return `traits::eof()`.

It is expected that derived classes provide a more efficient implementation by overriding this definition.

Reimplemented from std::basic_streambuf< _CharT, encoding_char_traits< _CharT > >.

Definition at line 483 of file fstream.tcc.

## Member Data Documentation

## ◆ _M_buf

char_type* std::basic_filebuf< _CharT, encoding_char_traits< _CharT > >::_M_buf
| protectedinherited

Pointer to the beginning of internal buffer.

Definition at line 148 of file fstream.

## ◆ _M_buf_allocated

bool std::basic_filebuf< _CharT, encoding_char_traits< _CharT > >::_M_buf_allocated
| protectedinherited

Definition at line 158 of file fstream.

## ◆ _M_buf_locale

locale std::basic_streambuf< _CharT, encoding_char_traits< _CharT > >::_M_buf_locale
| protectedinherited

Current locale setting.

Definition at line 201 of file streambuf.

## ◆ _M_buf_size

size_t std::basic_filebuf< _CharT, encoding_char_traits< _CharT > >::_M_buf_size
| protectedinherited

Actual size of internal buffer. This number is equal to the size of the put area + 1 position, reserved for the overflow char of a full area.

Definition at line 155 of file fstream.

## ◆ _M_codecvt

const __codecvt_type* std::basic_filebuf< _CharT, encoding_char_traits< _CharT > >::_M_codecvt
| protectedinherited

Definition at line 183 of file fstream.

## ◆ _M_ext_buf

char* std::basic_filebuf< _CharT, encoding_char_traits< _CharT > >::_M_ext_buf
| protectedinherited

Buffer for external characters. Used for input when codecvt::always_noconv() == false. When valid, this corresponds to eback().

Definition at line 190 of file fstream.

Referenced by overflow(), and pbackfail().

## ◆ _M_ext_buf_size

streamsize std::basic_filebuf< _CharT, encoding_char_traits< _CharT > >::_M_ext_buf_size
| protectedinherited

Size of buffer held by _M_ext_buf.

Definition at line 195 of file fstream.

## ◆ _M_ext_end

char* std::basic_filebuf< _CharT, encoding_char_traits< _CharT > >::_M_ext_end
| protectedinherited

Definition at line 203 of file fstream.

## ◆ _M_ext_next

const char* std::basic_filebuf< _CharT, encoding_char_traits< _CharT > >::_M_ext_next
| protectedinherited

Pointers into the buffer held by _M_ext_buf that delimit a subsequence of bytes that have been read but not yet converted. When valid, _M_ext_next corresponds to egptr().

Definition at line 202 of file fstream.

Referenced by overflow(), and pbackfail().

## ◆ _M_file

__file_type std::basic_filebuf< _CharT, encoding_char_traits< _CharT > >::_M_file
| protectedinherited

Definition at line 130 of file fstream.

## ◆ _M_in_beg

char_type* std::basic_streambuf< _CharT, encoding_char_traits< _CharT > >::_M_in_beg
| protectedinherited

Start of get area.

Definition at line 193 of file streambuf.

## ◆ _M_in_cur

char_type* std::basic_streambuf< _CharT, encoding_char_traits< _CharT > >::_M_in_cur
| protectedinherited

Current read area.

Definition at line 194 of file streambuf.

## ◆ _M_in_end

char_type* std::basic_streambuf< _CharT, encoding_char_traits< _CharT > >::_M_in_end
| protectedinherited

End of get area.

Definition at line 195 of file streambuf.

## ◆ _M_lock

__c_lock std::basic_filebuf< _CharT, encoding_char_traits< _CharT > >::_M_lock
| protectedinherited

Definition at line 127 of file fstream.

## ◆ _M_mode

ios_base::openmode std::basic_filebuf< _CharT, encoding_char_traits< _CharT > >::_M_mode
| protectedinherited

Place to stash in || out || in | out settings for current filebuf.

Definition at line 133 of file fstream.

## ◆ _M_out_beg

char_type* std::basic_streambuf< _CharT, encoding_char_traits< _CharT > >::_M_out_beg
| protectedinherited

Start of put area.

Definition at line 196 of file streambuf.

## ◆ _M_out_cur

char_type* std::basic_streambuf< _CharT, encoding_char_traits< _CharT > >::_M_out_cur
| protectedinherited

Current put area.

Definition at line 197 of file streambuf.

## ◆ _M_out_end

char_type* std::basic_streambuf< _CharT, encoding_char_traits< _CharT > >::_M_out_end
| protectedinherited

End of put area.

Definition at line 198 of file streambuf.

## ◆ _M_pback

char_type std::basic_filebuf< _CharT, encoding_char_traits< _CharT > >::_M_pback
| protectedinherited

Necessary bits for putback buffer management.

Note
  pbacks of over one character are not currently supported.

Definition at line 176 of file fstream.

## ◆ _M_pback_cur_save

char_type* std::basic_filebuf< _CharT, encoding_char_traits< _CharT > >::_M_pback_cur_save
| protectedinherited

Necessary bits for putback buffer management.

Note
  pbacks of over one character are not currently supported.

Definition at line 177 of file fstream.

## ◆ _M_pback_end_save

char_type* std::basic_filebuf< _CharT, encoding_char_traits< _CharT > >::_M_pback_end_save
| protectedinherited

Necessary bits for putback buffer management.

Note
  pbacks of over one character are not currently supported.

Definition at line 178 of file fstream.

## ◆ _M_pback_init

bool std::basic_filebuf< _CharT, encoding_char_traits< _CharT > >::_M_pback_init
| protectedinherited

Necessary bits for putback buffer management.

Note
  pbacks of over one character are not currently supported.

Definition at line 179 of file fstream.

## ◆ _M_reading

bool std::basic_filebuf< _CharT, encoding_char_traits< _CharT > >::_M_reading
| protectedinherited

_M_reading == false && _M_writing == false for uncommitted mode; _M_reading == true for read mode; _M_writing == true for write mode;

NB: _M_reading == true && _M_writing == true is unused.

Definition at line 167 of file fstream.

Referenced by seekpos(), and setbuf().

## ◆ _M_state_beg

__state_type std::basic_filebuf< _CharT, encoding_char_traits< _CharT > >::_M_state_beg
| protectedinherited

Definition at line 136 of file fstream.

## ◆ _M_state_cur

__state_type std::basic_filebuf< _CharT, encoding_char_traits< _CharT > >::_M_state_cur
| protectedinherited

Definition at line 141 of file fstream.

## ◆ _M_state_last

__state_type std::basic_filebuf< _CharT, encoding_char_traits< _CharT > >::_M_state_last
| protectedinherited

Definition at line 145 of file fstream.

## ◆ _M_writing

bool std::basic_filebuf< _CharT, encoding_char_traits< _CharT > >::_M_writing
| protectedinherited

Definition at line 168 of file fstream.

The documentation for this class was generated from the following file:

- enc_filebuf.h